VCMD0028030100000000COMPONENT          
Node "rSimResource"
{
Name "TurnUnit"
Id 1
NodeClass 
{
Id 1
Name ""
Feature "rTransformFeature"
{
Name "Transform_6"
Transform "Tz(-250)"
Feature "rGeoFeature"
{
Name "Geometry"
MaterialInherit Disabled
OnDemandLoad 0
UseBackfaces 0
Uri "geometry"
}
Feature "rFrameFeature"
{
Name "FrameIn"
Value 1 0 0 0 0 1 0 0 0 0 1 0 -700 0 700 1 
}
Feature "rFrameFeature"
{
Name "FrameOut"
Value 1 0 0 0 0 1 0 0 0 0 1 0 700 -6.03777e-47 700 1 
}
Feature "rPrimitiveBoxFeature"
{
Name "Block"
Matrix 1 0 0 0 0 1 0 0 0 0 1 0 -200 1200 250 1 
Material "white"
{
Ambient { Red 0.560784 Green 0.560784 Blue 0.560784 }
Diffuse { Red 0.937255 Green 0.937255 Blue 0.937255 }
}
Length "400"
Width "100"
Height "2000-250"
}
Feature "rPrimitiveBoxFeature"
{
Name "Block_2"
Matrix 1 0 0 0 0 1 0 0 0 0 1 0 -200 800 500 1 
Material "white"
{
Ambient { Red 0.560784 Green 0.560784 Blue 0.560784 }
Diffuse { Red 0.937255 Green 0.937255 Blue 0.937255 }
}
Length "400"
Width "400"
Height "100"
}
Feature "rPrimitiveBoxFeature"
{
Name "Block_3"
Matrix 1 0 0 0 0 1 0 0 0 0 1 0 -200 800 1900 1 
Material "white"
{
Ambient { Red 0.560784 Green 0.560784 Blue 0.560784 }
Diffuse { Red 0.937255 Green 0.937255 Blue 0.937255 }
}
Length "400"
Width "400"
Height "100"
}
Feature "rPrimitiveCylinderFeature"
{
Name "Cylinder"
Matrix 1 0 0 0 0 1 0 0 0 0 1 0 0 1000 600 1 
Material "chrome"
{
Ambient { Red 0.0588235 Green 0.0588235 Blue 0 }
Diffuse { Red 0.823529 Green 0.823529 Blue 0.823529 }
Specular
{
Color { Red 0.87451 Green 0.87451 Blue 0.87451 }
Shininess 0.015625
}
Texture
{
Uri "crome.tga"
EnvironmentMap
}
}
Radius "50"
Height "1300"
StartSweep "0"
EndSweep "360"
Sections "12"
Caps 1
}
Feature "rPrimitiveCylinderFeature"
{
Name "WrapCylinder"
Matrix 1 0 0 0 0 1 0 0 0 0 1 0 0 1000 650 1 
Material "reflective_glass"
{
Ambient { Red 0.301176 Green 0.301176 Blue 0.301176 }
Diffuse { Red 0.384314 Green 0.368627 Blue 0.309804 Alpha 0.39 }
Specular
{
Color { Red 0.94902 Green 0.94902 Blue 0.94902 }
Shininess 0.015625
}
Transparency { Constant Value 0.39 }
Texture
{
Uri "crome.tga"
EnvironmentMap
}
}
Radius "200"
Height "1200"
StartSweep "0"
EndSweep "360"
Sections "12"
Caps 1
}
Feature "rPrimitiveCylinderFeature"
{
Name "WrapCylinder_2"
Matrix 1 0 0 0 0 1 0 0 0 0 1 0 0 1000 650 1 
Material "dark_grey"
{
Ambient { Red 0.0980392 Green 0.0980392 Blue 0.0980392 }
Diffuse { Red 0.34902 Green 0.34902 Blue 0.34902 }
Specular
{
Color { Red 0.0117647 Green 0.0117647 Blue 0.0117647 }
Shininess 0.00020881
}
}
Radius "180"
Height "1200"
StartSweep "0"
EndSweep "360"
Sections "12"
Caps 1
}
Feature "rFrameFeature"
{
Name "Ref"
Value 1 0 0 0 0 1 0 0 0 0 1 0 200 1000 700 1 
}
Feature "rPrimitiveBoxFeature"
{
Name "Block_5"
Matrix 1 0 0 0 0 1 0 0 0 0 1 0 -350 0 250 1 
Material "white"
{
Ambient { Red 0.560784 Green 0.560784 Blue 0.560784 }
Diffuse { Red 0.937255 Green 0.937255 Blue 0.937255 }
}
Length "700"
Width "1200"
Height "200"
}
Feature "rFrameFeature"
{
Name "Frame_4"
Value 1 0 0 0 0 1 0 0 0 0 1 0 0 0 0 1 
}
}
VCID "d370c0aa-aed6-4e05-a77d-e6501bb9458f"
}
Functionality "rSimKinController"
{
Id 1
Name "ServoController"
Joints ""
{
JointInfo "rSimJointInfo"
{
Name "Joint_1"
MinValueExpression "-1e6"
MaxValueExpression "1e6"
InitialValue 0
MaxSpeed 100
MaxAcceleration 500
MaxDeceleration 500
LagTime 0
SettleTime 0
Index 0
JointType "TRANSLATIONAL"
}
}
RootNode "TurnUnit"
FlangeNode "Link1"
RootOffset ""
FlangeOffset ""
}
Functionality "rPythonScript"
{
Id 2
Name "PythonScript"
Script "from vcScript import *\n
\nglobal A
\nA = [77,154.5,258,330]
\n\ndef OnRun():
\n  global creator
\n  comp = getComponent()
\n  # Get handles to needed behaviours\n  path = comp.findBehaviour(\"One-DirectionalPath\")
\n  servo = comp.findBehaviour(\"ServoController\")\n  comp_signal = comp.findBehaviour(\"ComponentSignal\")
\n  inout_signal = comp.findBehaviour(\"BooleanSignal\")
\n  creator = comp.findBehaviour(\"FoilCreator\")
\n
\n  # Foil management
\n  ref1 = comp.findFeature(\"Ref1\")
\n  ref2 = comp.findFeature(\"Ref2\")
\n  ref3 = comp.findFeature(\"Ref3\")
\n  ref4 = comp.findFeature(\"Ref4\")
\n\n  # Main loop
\n  while True:
\n    # Turn path on
\n    path.Enabled = True
\n    path.CapacityAvailable = True
\n
\n    # Wait for component to arrive
\n    triggerCondition(lambda: getTrigger() == comp_signal)
\n    pallet = comp_signal.Value
\n
\n    # Turn path off and turn the table
\n    path.Enabled = False
\n    delay(2.0)
\n
\n    servo.moveJoint(0,A[0])
\n    createFoilSegment(pallet, ref1, 1200,1200)
\n
\n    servo.moveJoint(0,A[1])
\n    createFoilSegment(pallet, ref2, 800,1200)
\n
\n    servo.moveJoint(0,A[2])
\n    createFoilSegment(pallet, ref3, 1200,1200)
\n
\n    servo.moveJoint(0,A[3])
\n    createFoilSegment(pallet, ref4, 800,1200)
\n
\n    servo.moveJoint(0,720.0)
\n
\n    # Turn path on but don't allow other component to arrive
\n    path.Enabled = True
\n    path.CapacityAvailable = False
\n
\n    # Wait until component leaves and turn the table\n    triggerCondition(lambda: getTrigger() == inout_signal and inout_signal.Value == False)
\n    servo.moveImmediate(0)
\n
\ndef createFoilSegment(pallet, ref, l, h):
\n  global creator
\n  ns = pallet.findBehavioursByType(VC_CONTAINER)
\n  container = ns[0]
\n  foil = creator.create()
\n  container.grab(foil)
\n  foil.Length = l
\n  foil.Height = h
\n  m = pallet.PositionMatrix
\n  m.invert()
\n  foil.PositionMatrix = m * ref.PositionMatrix"
}
Functionality "rSimInterface"
{
Id 3
Name "OnetoOneInterface"
Flags 6
Section 
{
Name "NewSection"
Frame "FrameIn"
Fields
{
rSimFlowField
{
Name "Flow"
Func "One-DirectionalPath"
Port 0
}
}
}
}
Functionality "rSimInterface"
{
Id 4
Name "OnetoOneInterface_2"
Flags 6
Section 
{
Name "NewSection"
Frame "FrameOut"
Fields
{
rSimFlowField
{
Name "Flow"
Func "One-DirectionalPath"
Port 1
}
}
}
}
Functionality "rSimBoolSignal"
{
Id 5
Name "BooleanSignal"
Connections
{
"PythonScript"
}
}
Functionality "rSimResourcePtrSignal"
{
Id 6
Name "ComponentSignal"
Connections
{
"PythonScript"
}
}
Functionality "rPythonScript"
{
Id 7
Name "UpdateScript"
Script "from vcScript import *
\nfrom math import *\n
\nglobal A
\nA = [77,154.5,258,330]
\n\ndef OnSimulationUpdate(time):
\n  CalculateFilm()
\n
\ndef CalculateFilm():
\n  comp = getComponent()
\n  angle = comp.Joint_1
\n  if angle > 360.0:
\n    angle -= 360.0
\n  # print angle
\n
\n  ref = comp.findFeature(\"Ref\")
\n  ref1 = comp.findFeature(\"Ref1\")
\n  ref2 = comp.findFeature(\"Ref2\")
\n  ref3 = comp.findFeature(\"Ref3\")
\n  ref4 = comp.findFeature(\"Ref4\")
\n  foiler = comp.findNode(\"Foiler\")
\n  link = comp.findNode(\"Link1\")
\n
\n  frame = None
\n  if angle > A[3]:
\n    frame = ref1
\n  elif angle > A[2]:
\n    frame = ref4
\n  elif angle > A[1]:
\n    frame = ref3
\n  elif angle > A[0]:
\n    frame = ref2
\n  else:
\n    frame = ref1
\n
\n  M1 = ref.NodePositionMatrix
\n  M2 = link.PositionMatrix*frame.NodePositionMatrix
\n  P1 = M1.P
\n  P2 = M2.P
\n  D = P2 - P1
\n  comp.FoilLength = D.length()
\n
\n  # print frame.Name
\n
\n  comp.FoilAngle = atan(-D.Y/D.X)*(180/pi)
\n\n\n"
}
Functionality "rResourceCreator"
{
Id 8
Name "FoilCreator"
Flags 2
ContainerFlags 1
Capacity 999999
CapacityBlocks 
{
}
Connection "Output"
{
Id 0
Type 2
Name "Output"
Func 9
Port 0
}
Template "vcid:7b835ffb-a3ae-4d23-a0a8-612ccba200a6"
Interval 1
Limit 0
}
Location 1 4.02153e-87 0 0 -4.02153e-87 1 0 0 0 0 1 0 0 0 0 1 
VariableSpace ""
{
Variable "rTVariable<rDouble>"
{
Name "FoilAngle"
Value 65.9271
Group 65536
Settings 
{
VISIBLE
EDITABLE_DISCONNECTED
EDITABLE_CONNECTED
EDITABLE_SIMULATING
ON_EDIT_SIM_UPDATE
}
}
Variable "rTVariable<rDouble>"
{
Name "FoilLength"
Value 1250.15
Group 65537
Settings 
{
VISIBLE
EDITABLE_DISCONNECTED
EDITABLE_CONNECTED
EDITABLE_SIMULATING
ON_EDIT_SIM_UPDATE
}
}
Variable "rTVariable<rDouble>"
{
Name "ConveyorLength"
Value 1100
Group 65538
Settings 
{
VISIBLE
EDITABLE_DISCONNECTED
EDITABLE_CONNECTED
EDITABLE_SIMULATING
ON_EDIT_REBUILD
}
}
Variable "rTVariable<rDouble>"
{
Name "ConveyorWidth"
Value 900
Group 65539
Settings 
{
VISIBLE
EDITABLE_DISCONNECTED
EDITABLE_CONNECTED
EDITABLE_SIMULATING
ON_EDIT_REBUILD
}
}
Variable "rTVariable<rDouble>"
{
Name "ConveyorHeight"
Value 450
Group 65540
Settings 
{
VISIBLE
EDITABLE_DISCONNECTED
EDITABLE_CONNECTED
EDITABLE_SIMULATING
ON_EDIT_REBUILD
}
}
Variable "rTVariable<rDouble>"
{
Name "RollDiameter"
Value 100
Group 65541
Settings 
{
VISIBLE
EDITABLE_DISCONNECTED
EDITABLE_CONNECTED
EDITABLE_SIMULATING
ON_EDIT_REBUILD
}
}
Variable "rTVariable<rDouble>"
{
Name "RollSpacing"
Value 120
Group 65542
Settings 
{
VISIBLE
EDITABLE_DISCONNECTED
EDITABLE_CONNECTED
EDITABLE_SIMULATING
ON_EDIT_REBUILD
}
}
}
Node "rSimKinLink"
{
Name "Foiler"
Id 2
NodeClass 
{
Id 2
Name ""
Feature "rPrimitiveBoxFeature"
{
Name "Block_4"
Material "reflective_glass"
{
Ambient { Red 0.301176 Green 0.301176 Blue 0.301176 }
Diffuse { Red 0.384314 Green 0.368627 Blue 0.309804 Alpha 0.39 }
Specular
{
Color { Red 0.94902 Green 0.94902 Blue 0.94902 }
Shininess 0.015625
}
Transparency { Constant Value 0.39 }
Texture
{
Uri "crome.tga"
EnvironmentMap
}
}
Length "1"
Width "1"
Height "1200"
}
}
Functionality "rSimContainer"
{
Id 9
Name "ComponentContainer"
Flags 2
ContainerFlags 1
Capacity 999999
CapacityBlocks 
{
}
Connection "Input"
{
Id 0
Type 1
Name "Input"
Func 8
Port 0
}
Connection "Output"
{
Id 1
Type 2
Name "Output"
}
}
Offset "Tx(200).Tz(400).Ty(1000)"
JointTransform "Rz(-FoilAngle).Sx(FoilLength)"
}
Node "rSimKinLink"
{
Name "Link1"
Id 3
NodeClass 
{
Id 3
Name ""
Feature "rTransformFeature"
{
Name "Transform_2"
Matrix 1 0 0 0 0 1 0 0 0 0 1 0 -700 1.00145 250 1 
Transform "Rz(90).Ty(-(1400-1100)/2)"
Feature "rMirrorFeature"
{
Name "Mirror"
Feature "rLinearCloneFeature"
{
Name "LinearClone_2"
CountExpression "AmountOfFeet"
StepExpression "(ConveyorLength-200)/(AmountOfFeet-1)"
DirectionExpression "Vector(0,-1,0)"
Feature "rTransformFeature"
{
Name "geometry_feet"
Matrix -1 -1.22461e-16 0 0 1.22461e-16 -1 0 0 0 0 1 0 52.0521 2.05599e-14 0 1 
Transform "Tx(ConveyorWidth/2).Ty(100)"
Feature "rTransformFeature"
{
Name "Transform_5"
Matrix 1 0 0 0 0 1 0 0 0 0 1 0 9.15934e-15 -25 0 1 
Transform "Tz(ConveyorHeight-50-RollDiameter)"
Feature "rPrimitiveBoxFeature"
{
Name "Block_6"
Matrix -1 3.57342e-22 -1.22514e-16 0 3.57342e-22 1 -1.25129e-18 0 1.22514e-16 -1.25129e-18 -1 0 50.0021 -4.09395e-16 50 1 
Material "white"
{
Ambient { Red 0.560784 Green 0.560784 Blue 0.560784 }
Diffuse { Red 0.937255 Green 0.937255 Blue 0.937255 }
}
Length "ConveyorWidth/2"
Width "50"
Height "50"
}
}
Feature "rPrimitiveSphereFeature"
{
Name "Sphere"
Matrix 3.74915e-33 6.12303e-17 1 0 2.29562e-49 1 -6.12303e-17 0 -1 2.29562e-49 3.74915e-33 0 25 -4.4964e-15 -3.01218e-31 1 
Material "metal"
{
Ambient { Red 0.247059 Green 0.247059 Blue 0.247059 }
Diffuse { Red 0.482353 Green 0.537255 Blue 0.576471 }
Specular
{
Color { Red 0.960784 Green 0.960784 Blue 0.960784 }
Shininess 0.0390625
}
}
Radius "40"
StartSweep "0"
EndSweep "180"
Sections "12"
Spans "12"
Caps 1
}
Feature "rPrimitiveCylinderFeature"
{
Name "Cylinder_5"
Matrix 1 0 0 0 0 1 0 0 0 0 1 0 25 -1.53076e-15 0 1 
Material "metal"
{
Ambient { Red 0.247059 Green 0.247059 Blue 0.247059 }
Diffuse { Red 0.482353 Green 0.537255 Blue 0.576471 }
Specular
{
Color { Red 0.960784 Green 0.960784 Blue 0.960784 }
Shininess 0.0390625
}
}
Radius "10"
Height "100"
StartSweep "0"
EndSweep "360"
Sections "12"
Caps 1
}
Feature "rTransformFeature"
{
Name "Transform_3"
Transform "Tz(100)"
Feature "rPrimitiveBoxFeature"
{
Name "Block_7"
Matrix 1 0 0 0 0 1 0 0 0 0 1 0 -2 -27 0 1 
Material "blue_grey"
{
Ambient { Red 0.0784314 Green 0.0784314 Blue 0.0784314 }
Diffuse { Red 0.505882 Green 0.470588 Blue 0.662745 }
Specular
{
Color { Red 1 Green 1 Blue 1 }
Shininess 0.0251463
}
}
Length "54"
Width "54"
Height "20"
}
Feature "rPrimitiveBoxFeature"
{
Name "Block_8"
Matrix 1 0 0 0 0 1 0 0 0 0 1 0 -3.05311e-15 -25 0 1 
Material "white"
{
Ambient { Red 0.560784 Green 0.560784 Blue 0.560784 }
Diffuse { Red 0.937255 Green 0.937255 Blue 0.937255 }
}
Length "50"
Width "50"
Height "ConveyorHeight-RollDiameter-100"
}
}
}
}
Feature "rTransformFeature"
{
Name "Geometry_Structure"
Transform "Tz(ConveyorHeight).Tx(ConveyorWidth/2)"
Feature "rTransformFeature"
{
Name "Transform_4"
Transform "Tz(-RollDiameter/2)"
Feature "rPrimitiveBoxFeature"
{
Name "Block_9"
Matrix 1 7.29663e-50 -5.95835e-34 0 7.29663e-50 -1 1.22461e-16 0 -5.95835e-34 -1.22461e-16 -1 0 0 0 0 1 
Material "white"
{
Ambient { Red 0.560784 Green 0.560784 Blue 0.560784 }
Diffuse { Red 0.937255 Green 0.937255 Blue 0.937255 }
}
Length "RollDiameter/2"
Width "ConveyorLength"
Height "RollDiameter-RollDiameter/2"
}
Feature "rPrimitiveCylinderFeature"
{
Name "Cylinder_2"
Matrix 1 3.74913e-33 -6.123e-17 0 6.123e-17 6.12303e-17 1 0 3.74913e-33 -1 6.12303e-17 0 -2.74225e-14 6.40878e-30 2.14273e-14 1 
Material "light_aqua"
{
Ambient { Red 0.0431373 Green 0.133333 Blue 0.309804 }
Diffuse { Red 0.682353 Green 0.741176 Blue 0.815686 }
Specular
{
Color { Red 0.309804 Green 0.423529 Blue 0.568628 }
Shininess 0.0078125
}
}
Radius "RollDiameter/2"
Height "ConveyorLength"
StartSweep "0"
EndSweep "90"
Sections "6"
Caps 1
}
}
Feature "rTransformFeature"
{
Name "Transform"
Transform "Tz(-RollDiameter)"
Feature "rPrimitiveCylinderFeature"
{
Name "Cylinder_3"
Matrix -6.12303e-17 -1.19082e-31 -1 0 1 6.12303e-17 -6.12303e-17 0 6.12303e-17 -1 1.15333e-31 0 -2.14273e-14 8.04494e-30 2.75613e-14 1 
Material "light_aqua"
{
Ambient { Red 0.0431373 Green 0.133333 Blue 0.309804 }
Diffuse { Red 0.682353 Green 0.741176 Blue 0.815686 }
Specular
{
Color { Red 0.309804 Green 0.423529 Blue 0.568628 }
Shininess 0.0078125
}
}
Radius "RollDiameter/2"
Height "ConveyorLength"
StartSweep "0"
EndSweep "90"
Sections "6"
Caps 1
}
}
Feature "rPrimitiveBoxFeature"
{
Name "Block_10"
Matrix 1 7.29663e-50 -5.95835e-34 0 7.29663e-50 -1 1.22461e-16 0 -5.95835e-34 -1.22461e-16 -1 0 0 0 0 1 
Material "white"
{
Ambient { Red 0.560784 Green 0.560784 Blue 0.560784 }
Diffuse { Red 0.937255 Green 0.937255 Blue 0.937255 }
}
Length "1"
Width "ConveyorLength"
Height "RollDiameter+RollDiameter/2"
}
}
Feature "rTransformFeature"
{
Name "Geometry_Rolls"
Transform "Tz(ConveyorHeight-RollDiameter/2).Rz(-90).Rx(90)"
Feature "rTransformFeature"
{
Name "RollDiameter"
Transform "Tx(RollDiameter/2)"
Feature "rLinearCloneFeature"
{
Name "LinearClone"
CountExpression "ConveyorLength/RollSpacing"
StepExpression "RollSpacing"
DirectionExpression "Vector(1,0,0)"
Feature "rPrimitiveCylinderFeature"
{
Name "Cylinder_2"
Material "metal"
{
Ambient { Red 0.247059 Green 0.247059 Blue 0.247059 }
Diffuse { Red 0.482353 Green 0.537255 Blue 0.576471 }
Specular
{
Color { Red 0.960784 Green 0.960784 Blue 0.960784 }
Shininess 0.0390625
}
}
Radius "RollDiameter/2"
Height "ConveyorWidth/2"
StartSweep "0"
EndSweep "360"
Sections "12"
Caps 1
}
}
}
}
}
}
Feature "rFrameFeature"
{
Name "Ref4"
Value 6.12303e-17 1 0 0 -1 6.12303e-17 0 0 0 0 1 0 602 -402 700 1 
}
Feature "rFrameFeature"
{
Name "Ref3"
Value 1 0 0 0 0 1 0 0 0 0 1 0 -602 -402 700 1 
}
Feature "rFrameFeature"
{
Name "Ref2"
Value 6.12303e-17 -1 0 0 1 6.12303e-17 0 0 0 0 1 0 -602 402 700 1 
}
Feature "rFrameFeature"
{
Name "Ref1"
Value -1 1.22461e-16 0 0 -1.22461e-16 -1 0 0 0 0 1 0 602 402 700 1 
}
Feature "rFrameFeature"
{
Name "Frame_3"
Value 1 0 0 0 0 1 0 0 0 0 1 0 700 0 700 1 
}
Feature "rFrameFeature"
{
Name "Frame_2"
Value 1 0 0 0 0 1 0 0 0 0 1 0 0 0 700 1 
}
Feature "rFrameFeature"
{
Name "Frame"
Value 1 0 0 0 0 1 0 0 0 0 1 0 -700 0 700 1 
}
}
Functionality "rMovementPath"
{
Id 10
Name "One-DirectionalPath"
Flags 8194
ContainerFlags 1
Capacity 1
CapacityBlocks 
{
}
TransitionSignal "BooleanSignal"
Speed 200
Connection "Input"
{
Id 0
Type 1
Name "Input"
}
Connection "Output"
{
Id 1
Type 2
Name "Output"
}
Path
{
Frames
{
Frame { Name "Frame" }
Frame { Name "Frame_2" }
Frame { Name "Frame_3" }
}
}
Sensors
{
Func "ComponentPathSensor"
}
RetainOffset 0
}
Functionality "rResourceSensor"
{
Id 11
Name "ComponentPathSensor"
Frame "Frame_2"
ResourceSignal "ComponentSignal"
BoolSignalValue 1
}
Offset "Tz(-250)"
JointTransform "Rz(-Joint_1)"
}
}
